with Interfaces; use Interfaces;

package body CosNotifyChannelAdmin_ProxyConsumer_Hash is

   P : constant array (0 .. 4) of Natural :=
     (1, 3, 4, 8, 10);

   T1 : constant array (0 .. 4) of Unsigned_8 :=
     (13, 32, 23, 8, 10);

   T2 : constant array (0 .. 4) of Unsigned_8 :=
     (30, 33, 1, 0, 10);

   G : constant array (0 .. 34) of Unsigned_8 :=
     (0, 0, 0, 0, 14, 0, 0, 15, 0, 6, 3, 16, 0, 0, 0, 0, 10, 0, 11, 16, 8,
      0, 0, 7, 0, 7, 4, 0, 0, 9, 4, 0, 5, 0, 0);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 35;
         F2 := (F2 + Natural (T2 (K)) * J) mod 35;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 17;
   end Hash;

end CosNotifyChannelAdmin_ProxyConsumer_Hash;
